package org.honours.CollectionSpace;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;

import org.expeditee.actions.Navigation;
import org.expeditee.gui.Frame;
import org.expeditee.gui.FrameIO;
import org.expeditee.gui.MessageBay;
import org.expeditee.items.ItemParentStateChangedEvent;
import org.expeditee.items.Picture;
import org.expeditee.items.Text;
import org.honours.collection.Collection;
import org.honours.gui.HonoursFrameIO;
import org.honours.items.PictureInformation;

public class CollectionSpace {
	
	//the collection this collection space is associated with
	private Collection _associatedCollection;
	
	private String _name;
	
	//FOr storing thumbnails for the collection space
	private String _thumbnailsDirectory;
	
	private List<Picture> _thumbnails = new ArrayList<Picture>();
	
	private int _startX = 150;
	private int _startY = 150;
	
	public static final int _gap = 20;
	public static final int _columns = 4;
	public static final int _imageSize = 150;
	public static final int _rows = 3;
	
	public CollectionSpace(){
		
	}
	
	public CollectionSpace(Collection associatedCollection){
		_associatedCollection = associatedCollection;
		_name = "collectionspace-" + _associatedCollection.getName();
		_thumbnailsDirectory = FrameIO.IMAGES_FOLDER + "thumbnails-" +
		_associatedCollection.getName();
	}
	
	public void setAssociatedCollection(Collection assocCollection){
		_associatedCollection = assocCollection;
	}
	
	public Collection getAssociatedCollection(){
		return _associatedCollection;
	}
	
	public void setName(String name){
		_name = name;
	}
	
	public String getName(){
		return _name;
	}
	
	public void setThumbnailsDirectory(String dir){
		
		_thumbnailsDirectory = dir;
		
	}
	
	public String getThumbnailsDirectory(){
		return _thumbnailsDirectory;
	}
	
	public void generate(){
		
		
	}
	
	/** Method to output thumbnails into collection space **/
	private void writeThumbnails(){
		
		Frame currFrame = null;
		int currX = _startX;
		int currY = _startY;
		
		int frameIter = 1;
		
		generateNavigationLinks(frameIter);
		generateDropBox(frameIter);
		
		for(int i = 0; i < _thumbnails.size(); i++)
		{
			Picture currPic = _thumbnails.get(i);
			
			if(i % _columns ==0 && i == 0){
				
			}else if(i % _columns == 0 && i > 0){
				currX = _startX;
				currY += _gap + _imageSize;
			}else{
				currX += _gap + _imageSize;
			}
			
			//Create a new frame to display next lot of items.
			if(i % (_columns * _rows) == 0 && i < _columns * _rows){
				currFrame = FrameIO.LoadFrame(_name + frameIter);
				
			}else if(i % (_columns * _rows) == 0 && i >= _columns * _rows){
				frameIter++;
				Frame check = FrameIO.LoadFrame(_name + frameIter);
				if(check == null){
					//create new frame
					HonoursFrameIO.generateFrame(frameIter, _name);
					currFrame = FrameIO.LoadFrame(_name + frameIter);
					
					currX = _startX;
					currY = _startY;
					generateNavigationLinks(frameIter);
					generateDropBox(frameIter);
				}

			}
			
			currFrame.addText(currX, currY, currPic.getSource().getText(),
					null, currPic.getLink());
			currFrame.setSaved();
		}
		
		_associatedCollection.setCollectionSpace(this);
	}
	
	private void generateNavigationLinks(int frameIter){
		
		String backText = "<<";
		String forwardText = ">>";
		
		int backButtonX = _startX/2;
		int forwardButtonX = _startX + (_columns*_gap)+(_columns*_imageSize);
		int buttonPosY = ((_rows*_imageSize) + (_rows*_gap))/2;
		
		Frame currFrame = FrameIO.LoadFrame(_name+frameIter);
		currFrame.addText(backButtonX,buttonPosY,backText,"RotateBack");
		currFrame.addText(forwardButtonX,buttonPosY,forwardText,"RotateNext");
		currFrame.setSaved();
	}
	
	private void generateDropBox(int frameIter){
		
	}
	
	private void createCollectionSpace(){
		Frame check = FrameIO.LoadFrame(_name + "1");
		
		if(check != null){
			FrameIO.deleteFrameset(_name);
		}
		
		try{
			FrameIO.CreateNewFrameset(_name);
		}catch(Exception e){
			e.printStackTrace();
		}
	}
}
