package org.honours.collection;

import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;

import org.expeditee.gui.Frame;
import org.honours.Main;
import org.honours.CollectionSpace.*;

public class Collection {

	private String _name;
	private CopyOnWriteArrayList<CollectionItem> _items;
	private CollectionInformation _collectionInfo;
	
	private CollectionSpace _collectionSpace;
	
	public Collection() {}
	
	public Collection(String name){
		_name = name;
		_items = new CopyOnWriteArrayList<CollectionItem>();
	}
	
	public void setName(String s){
		_name = s;
	}
	
	public String getName(){
		return _name;
	}
	
	public void setCollectionInformation(CollectionInformation ci){
		_collectionInfo = ci;
	}
	
	public CollectionInformation getCollectionInformation(){
		return _collectionInfo;
	}
	
	public void addItem(CollectionItem item){
		_items.add(item);
	}
	
	public List<CollectionItem> getItems()
	{
		return _items;
	}
	
	public void resetItems(){
		//_items = new ArrayList<CollectionItem>();
		_items = new CopyOnWriteArrayList<CollectionItem>();
	}
	
	public void setCollectionSpace(CollectionSpace cs){
		_collectionSpace = cs;
	}
	
public static Collection findCollection(Frame frame){
		
		if(frame == null)
			return null;
		
		String framesetName = frame.getFramesetName();
		for(Collection c : Main._collections){
			if(c.getName().equals(framesetName))
				return c;
		}
		return null;
	}
	
	/**
	 * Find a collection with the matching
	 * passed (frameset) name.
	 * @param name
	 * @return
	 */
	public static Collection findCollection(String name){
		
		if(name == null)
			return null;
		else if(name.equals(""))
			return null;
		
		for(Collection c : Main._collections){
			if(c.getName().equals(name))
				return c;
		}
		
		return null;
	}
	
	public static int getCollectionPosition(Collection c){
		
		if(c == null)
			return -1;
		
		for(int i = 0; i < Main._collections.size(); i++){
			Collection currCol = Main._collections.get(i);
			if(currCol == c)
				return i;
		}
		
		return -1;
	}
	
	public static int getCollectionPosition(Frame frame){
		Collection find = findCollection(frame);
		if(find == null)
			return -1;
		
		for(int i = 0; i < Main._collections.size(); i++){
			
			Collection currCol = Main._collections.get(i);
			if(currCol == find)
				return i;
			
		}
		
		return -1;
	}
	
}
